const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const enrollment_learnings = sequelize.define(
    'enrollment_learnings',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      due_date: {
        type: DataTypes.DATE,
      },

      status: {
        type: DataTypes.ENUM,

        values: ['Assigned', 'Completed', 'Overdue'],
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  enrollment_learnings.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.enrollment_learnings.belongsTo(db.employees, {
      as: 'employee',
      foreignKey: {
        name: 'employeeId',
      },
      constraints: false,
    });

    db.enrollment_learnings.belongsTo(db.learning_courses, {
      as: 'course',
      foreignKey: {
        name: 'courseId',
      },
      constraints: false,
    });

    db.enrollment_learnings.belongsTo(db.employees, {
      as: 'assigned_by',
      foreignKey: {
        name: 'assigned_byId',
      },
      constraints: false,
    });

    db.enrollment_learnings.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });

    db.enrollment_learnings.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.enrollment_learnings.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return enrollment_learnings;
};
